﻿#Region "Copyright Note"
'' 
'' (C) Copyright 2009 by Autodesk, Inc.
'' 
'' Permission to use, copy, modify, and distribute this software in
'' object code form for any purpose and without fee is hereby granted,
'' provided that the above copyright notice appears in all copies and
'' that both that copyright notice and the limited warranty and
'' restricted rights notice below appear in all supporting
'' documentation.
''
'' AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
'' AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
'' MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
'' DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
'' UNINTERRUPTED OR ERROR FREE.
'' 
'' Use, duplication, or disclosure by the U.S. Government is subject to
'' restrictions set forth in FAR 52.227-19 (Commercial Computer
'' Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
'' (Rights in Technical Data and Computer Software), as applicable.
''
#End Region

#Region "Imports"
'' set here or set it in the project properties/references. (I'm setting the project here for VB.NET) 
''
Imports System.Reflection
Imports System.Collections.Specialized '' need this for StringCollection
'Imports System.Windows.Forms
' AutoCAD
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.Geometry
' ACA (Aec)
Imports Autodesk.Aec.DatabaseServices
Imports Autodesk.Aec.Arch.DatabaseServices
Imports Autodesk.Aec.PropertyData.DatabaseServices '' we need this for prop set def 

' To resolve Object/Entity ambiguities
Imports AcObject = Autodesk.AutoCAD.DatabaseServices.DBObject
Imports AecObject = Autodesk.Aec.DatabaseServices.DBObject
Imports AcEntity = Autodesk.AutoCAD.DatabaseServices.Entity
Imports AecEntity = Autodesk.Aec.DatabaseServices.Entity

' To resolve Application ambiguities
Imports AcadApp2 = Autodesk.AutoCAD.ApplicationServices.Application
'Imports WinApp = System.Windows.Forms.Application

' To resolve TransactionManager ambiguities
Imports DbTrMgr = Autodesk.AutoCAD.DatabaseServices.TransactionManager 'wraps AcDbTransactionManager
Imports AppTrMgr = Autodesk.AutoCAD.ApplicationServices.TransactionManager 'wraps AcTransactionManager

' To resolve ObjectId ambiguities
Imports ObjectId = Autodesk.AutoCAD.DatabaseServices.ObjectId
Imports ObjectIdCollection = Autodesk.AutoCAD.DatabaseServices.ObjectIdCollection

' specific to this lab
Imports ScheduleLabs

#End Region

''
''  nothing special here.  just to notify the user at the load time... 
''

Public Class ACANet_ScheduleLabs
    Implements IExtensionApplication

    Public Sub Initialize() Implements Autodesk.AutoCAD.Runtime.IExtensionApplication.Initialize

        ''  just signaling to the user that this is being loaded... 
        '' 
        Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor
        ed.WriteMessage("Loading ACA Schedule Labs... " + vbCrLf)

    End Sub

    Public Sub Terminate() Implements Autodesk.AutoCAD.Runtime.IExtensionApplication.Terminate

    End Sub

    ''
    ''  list commands defined in this lab to the command window. (just for convenience. nothing special here.)  
    ''
    <CommandMethod("ACANetScheduleLabs", "AcaHelp", CommandFlags.Modal)> _
    Public Sub listCommands()

        Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor
        ed.WriteMessage("  -- Schedule Labs Command List -- " + vbCrLf)
        ''  lab1 
        ed.WriteMessage("AcaCreatePropSetDef" + vbCrLf)
        ed.WriteMessage("AcaListAutomaticPropertySource" + vbCrLf)
        ed.WriteMessage("AcaImportPropSetDef" + vbCrLf)
        ''  lab2 
        ed.WriteMessage("AcaAttachPropertySet" + vbCrLf)
        ed.WriteMessage("AcaAttachPropertySetToAllDoors" + vbCrLf)
        ''  lab3 
        ed.WriteMessage("AcaAnchorTag" + vbCrLf)
        ed.WriteMessage("AcaImportMvBlockDef" + vbCrLf)
        ''  lab4
        ed.WriteMessage("AcaCreateScheduleTableStyle" + vbCrLf)
        ''  lab5
        ed.WriteMessage("AcaCreateScheduleTable" + vbCrLf)
        ''  lab6
        ed.WriteMessage("AcaHelp" + vbCrLf)

    End Sub

End Class