
// $Header: //Desktop/Source/TestTools/MgdDbgAec/App/AppContextMenu.cs#1 $
// $Author: fergusja $ $DateTime: 2007/03/16 11:08:08 $ $Change: 68854 $
//
// (C) Copyright 2004 by Autodesk, Inc. 
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//

using System;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.Windows;

namespace MgdDbgAec
{
	/// <summary>
	/// The AppContextMenu for our app.
	/// </summary>
	
    public class AppContextMenu
    {
        static ContextMenuExtension m_appMenu = null;

        public static void
            AddContextMenu()
        {
            m_appMenu = new ContextMenuExtension();
            m_appMenu.Title = "MgdDbgAec";
			
            Application.AddDefaultContextMenuExtension(m_appMenu);
        }
		
        private static void
            ExecuteCommand(Object o, EventArgs e)
        {
            MgdDbg.AppContextMenuItem mnuItem = (MgdDbg.AppContextMenuItem)o;

            string fullCmdLine = string.Format("_{0}\n", mnuItem.CommandName);
            Application.DocumentManager.MdiActiveDocument.SendStringToExecute(fullCmdLine, false, false, true);
        }

        public static void
        RemoveContextMenu()
        {
            Application.RemoveDefaultContextMenuExtension(m_appMenu);
        }
    }
}
