
// $Header: //Desktop/Source/TestTools/MgdDbgAec/ObjTests/QueryStructure.cs#1 $
// $Author: fergusja $ $DateTime: 2008/03/04 16:12:35 $ $Change: 94604 $
//
// (C) Copyright 2008 by Autodesk, Inc. 
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//

using System;
using System.Diagnostics;
using System.Collections;
using System.Windows.Forms;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.Colors;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.Runtime;
using MgdDbg;
using MgdDbg.Test;

using AcDb        = Autodesk.AutoCAD.DatabaseServices;
using AecDb       = Autodesk.Aec.DatabaseServices;
using AecGe       = Autodesk.Aec.Geometry;
using AecAppSrvcs = Autodesk.Aec.ApplicationServices;
using StructureDb = Autodesk.Aec.Structural.DatabaseServices;
using AcadApp     = Autodesk.AutoCAD.ApplicationServices.Application;
using AecModeler  = Autodesk.Aec.Modeler;

namespace MgdDbgAec.ObjTests
{
	/// <summary>
	/// Summary description for QueryEntTests.
	/// </summary>
	public class QueryStructure : MgdDbgTestFuncs
	{
        private Database    m_db = null;

		public
		QueryStructure()
		{		    
            m_testFrameworkFuncs.Add(new MgdDbgTestFuncInfo("Member Style Dictionary", "Basic dictionary query", typeof(AecDb.Dictionary), new MgdDbgTestFuncInfo.TestFunc(MemberStyleDictionary), MgdDbgTestFuncInfo.TestType.Query));
        }
                
        public void
        MemberStyleDictionary()
        {
            m_db = MgdDbg.Utils.Db.GetCurDwg();

            using (StructureDb.DictionaryMemberStyle dDict = new StructureDb.DictionaryMemberStyle(m_db))
            {
                MgdDbg.Snoop.Forms.Objects snoopForm = new MgdDbg.Snoop.Forms.Objects(dDict);
                snoopForm.ShowDialog();
            }
        }
        
	}	
}
