
// $Header: //Desktop/Source/TestTools/MgdDbgAec/Utils/Ui/SelectStyle.cs#1 $
// $Author: fergusja $ $DateTime: 2007/03/16 11:08:08 $ $Change: 68854 $
//
// (C) Copyright 2004 by Autodesk, Inc. 
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//

using System;
using System.Diagnostics;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Autodesk.Aec.DatabaseServices;
using Autodesk.Aec.Arch.DatabaseServices;
using Autodesk.Aec.PropertyData.DatabaseServices;
using Autodesk.AutoCAD.DatabaseServices;
using MgdDbg;

using AcDb = Autodesk.AutoCAD.DatabaseServices;

namespace MgdDbgAec.Utils.Ui
{
	/// <summary>
	/// Summary description for SelectStyle.
	/// </summary>
	public class SelectStyle : System.Windows.Forms.Form
	{
        private System.Windows.Forms.ListView       m_lvStyles;
        private System.Windows.Forms.Button         m_bnOk;
        private System.Windows.Forms.Button         m_bnCancel;
        private System.Windows.Forms.ColumnHeader   m_lvColName;
        private System.Windows.Forms.ColumnHeader   m_lvColDesc;
        
        private Dictionary      m_styleDict         = null;
        private AcDb.ObjectId   m_selectedStyleId   = new AcDb.ObjectId();
        
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public
		SelectStyle(Dictionary styleDict)
		{
		    m_styleDict = styleDict;
		    
			InitializeComponent();

            FillStyleControl(styleDict);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		
		protected override void
		Dispose(bool disposing)
		{
			if (disposing) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.m_lvStyles = new System.Windows.Forms.ListView();
            this.m_bnOk = new System.Windows.Forms.Button();
            this.m_bnCancel = new System.Windows.Forms.Button();
            this.m_lvColName = new System.Windows.Forms.ColumnHeader();
            this.m_lvColDesc = new System.Windows.Forms.ColumnHeader();
            this.SuspendLayout();
            // 
            // m_lvStyles
            // 
            this.m_lvStyles.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right);
            this.m_lvStyles.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                         this.m_lvColName,
                                                                                         this.m_lvColDesc});
            this.m_lvStyles.FullRowSelect = true;
            this.m_lvStyles.GridLines = true;
            this.m_lvStyles.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
            this.m_lvStyles.HideSelection = false;
            this.m_lvStyles.Location = new System.Drawing.Point(16, 16);
            this.m_lvStyles.MultiSelect = false;
            this.m_lvStyles.Name = "m_lvStyles";
            this.m_lvStyles.Size = new System.Drawing.Size(584, 256);
            this.m_lvStyles.TabIndex = 0;
            this.m_lvStyles.View = System.Windows.Forms.View.Details;
            this.m_lvStyles.SelectedIndexChanged += new System.EventHandler(this.OnSelectedStyleChanged);
            // 
            // m_bnOk
            // 
            this.m_bnOk.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.m_bnOk.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.m_bnOk.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.m_bnOk.Location = new System.Drawing.Point(227, 296);
            this.m_bnOk.Name = "m_bnOk";
            this.m_bnOk.TabIndex = 1;
            this.m_bnOk.Text = "OK";
            // 
            // m_bnCancel
            // 
            this.m_bnCancel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.m_bnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.m_bnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.m_bnCancel.Location = new System.Drawing.Point(315, 296);
            this.m_bnCancel.Name = "m_bnCancel";
            this.m_bnCancel.TabIndex = 2;
            this.m_bnCancel.Text = "Cancel";
            // 
            // m_lvColName
            // 
            this.m_lvColName.Text = "Name";
            this.m_lvColName.Width = 250;
            // 
            // m_lvColDesc
            // 
            this.m_lvColDesc.Text = "Description";
            this.m_lvColDesc.Width = 400;
            // 
            // SelectStyle
            // 
            this.AcceptButton = this.m_bnOk;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this.m_bnCancel;
            this.ClientSize = new System.Drawing.Size(616, 334);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this.m_bnCancel,
                                                                          this.m_bnOk,
                                                                          this.m_lvStyles});
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.MinimumSize = new System.Drawing.Size(400, 190);
            this.Name = "SelectStyle";
            this.ShowInTaskbar = false;
            this.Text = "Select Style";
            this.ResumeLayout(false);

        }
		#endregion
		
		private void
		FillStyleControl(Dictionary styleDict)
		{
		        // walk the dictionary and add all the Style/Description pairs to the 
		        // list control
            AcDb.ObjectIdCollection styleIds = styleDict.Records;
		    using (TransactionHelper trHlp = new TransactionHelper(styleDict.Database)) {
		        trHlp.Start();
		        
		        foreach (AcDb.ObjectId styleId in styleIds) {
		            DictionaryRecord rec = (DictionaryRecord)trHlp.Transaction.GetObject(styleId, OpenMode.ForRead);
		            string styleName = rec.AlternateName;
		            if (styleName == string.Empty)
		                styleName = rec.Name;
		                
                    ListViewItem lvItem = new ListViewItem(styleName);
                    lvItem.SubItems.Add(rec.Description);
                                            
                    lvItem.Tag = styleId;
                    m_lvStyles.Items.Add(lvItem);
                }
                		        
		        trHlp.Commit();
		    }
		        // by default, select the first item in the list
		    if (m_lvStyles.Items.Count > 0)
		        m_lvStyles.Items[0].Selected = true;
		}

        private void
        OnSelectedStyleChanged(object sender, System.EventArgs e)
        {
            Debug.Assert((m_lvStyles.SelectedItems.Count > 1) == false);
                
            if (m_lvStyles.SelectedItems.Count != 0) {
                m_selectedStyleId = (AcDb.ObjectId)m_lvStyles.SelectedItems[0].Tag;
            }
        }

        public AcDb.ObjectId
        SelectedStyleId()
        {
            return m_selectedStyleId;
        }
           
        #region Static functions to handle a particular dictionary type

        public static AcDb.ObjectId
        GetPolygonStyleId(Database db)
        {
            AcDb.ObjectId styleId = new AcDb.ObjectId();
            
		    using (DictionaryPolygonStyle dict = new DictionaryPolygonStyle(db)) {
		        Utils.Ui.SelectStyle selStyleForm = new Utils.Ui.SelectStyle(dict);
		        selStyleForm.Text = "Select Polygon Style";
		        if (selStyleForm.ShowDialog() == DialogResult.OK)
        	        styleId = selStyleForm.SelectedStyleId();
		    }
		    
		    if (styleId.IsNull) {
		        MessageBox.Show("No styles are available to choose from.");
		    }
		    
		    return styleId;
        }

        public static AcDb.ObjectId
        GetMassElementStyleId(Database db)
        {
            AcDb.ObjectId styleId = new AcDb.ObjectId();
            
		    using (DictionaryMassElementStyle dict = new DictionaryMassElementStyle(db)) {
		        Utils.Ui.SelectStyle selStyleForm = new Utils.Ui.SelectStyle(dict);
		        selStyleForm.Text = "Select Mass Element Style";
		        if (selStyleForm.ShowDialog() == DialogResult.OK)
        	        styleId = selStyleForm.SelectedStyleId();
		    }
		    
		    if (styleId.IsNull) {
		        MessageBox.Show("No styles are available to choose from.");
		    }
		    
		    return styleId;
        }
        
        public static AcDb.ObjectId
        GetMvBlockDefinitionId(Database db)
        {
            AcDb.ObjectId styleId = new AcDb.ObjectId();
            
		    using (DictionaryMultiViewBlockDefinition dict = new DictionaryMultiViewBlockDefinition(db)) {
		        Utils.Ui.SelectStyle selStyleForm = new Utils.Ui.SelectStyle(dict);
		        selStyleForm.Text = "Select Mutli-View Block Definition";
		        if (selStyleForm.ShowDialog() == DialogResult.OK)
        	        styleId = selStyleForm.SelectedStyleId();
		    }
		    
		    if (styleId.IsNull) {
		        MessageBox.Show("No definitions are available to choose from.");
		    }
		    
		    return styleId;
        }
        
        public static AcDb.ObjectId
        GetDoorStyleId(Database db)
        {
            AcDb.ObjectId styleId = new AcDb.ObjectId();
            
		    using (DictionaryDoorStyle dict = new DictionaryDoorStyle(db)) {
		        Utils.Ui.SelectStyle selStyleForm = new Utils.Ui.SelectStyle(dict);
		        selStyleForm.Text = "Select Door Style";
		        if (selStyleForm.ShowDialog() == DialogResult.OK)
        	        styleId = selStyleForm.SelectedStyleId();
		    }
		    
		    if (styleId.IsNull) {
		        MessageBox.Show("No styles are available to choose from.");
		    }
		    
		    return styleId;
        }
        
        public static AcDb.ObjectId
        GetWindowStyleId(Database db)
        {
            AcDb.ObjectId styleId = new AcDb.ObjectId();
            
		    using (DictionaryWindowStyle dict = new DictionaryWindowStyle(db)) {
		        Utils.Ui.SelectStyle selStyleForm = new Utils.Ui.SelectStyle(dict);
		        selStyleForm.Text = "Select Window Style";
		        if (selStyleForm.ShowDialog() == DialogResult.OK)
        	        styleId = selStyleForm.SelectedStyleId();
		    }
		    
		    if (styleId.IsNull) {
		        MessageBox.Show("No styles are available to choose from.");
		    }
		    
		    return styleId;
        }

        public static AcDb.ObjectId
        GetWallStyleId(Database db)
        {
            AcDb.ObjectId styleId = new AcDb.ObjectId();
            
		    using (DictionaryWallStyle dict = new DictionaryWallStyle(db)) {
		        Utils.Ui.SelectStyle selStyleForm = new Utils.Ui.SelectStyle(dict);
		        selStyleForm.Text = "Select Wall Style";
		        if (selStyleForm.ShowDialog() == DialogResult.OK)
        	        styleId = selStyleForm.SelectedStyleId();
		    }
		    
		    if (styleId.IsNull) {
		        MessageBox.Show("No styles are available to choose from.");
		    }
		    
		    return styleId;
        }
        
        public static AcDb.ObjectId
        GetWindowAssemblyStyleId(Database db)
        {
            AcDb.ObjectId styleId = new AcDb.ObjectId();
            
            using (DictionaryWindowAssemblyStyle dict = new DictionaryWindowAssemblyStyle(db)) {
                Utils.Ui.SelectStyle selStyleForm = new Utils.Ui.SelectStyle(dict);
                selStyleForm.Text = "Select Window Assembly Style";
                if (selStyleForm.ShowDialog() == DialogResult.OK)
                    styleId = selStyleForm.SelectedStyleId();
            }
		    
            if (styleId.IsNull) {
                MessageBox.Show("No styles are available to choose from.");
            }
		    
            return styleId;
        }
        
        public static AcDb.ObjectId
        GetPropertySetDefId(Database db)
        {
            AcDb.ObjectId styleId = new AcDb.ObjectId();
            
            using (DictionaryPropertySetDefinitions dict = new DictionaryPropertySetDefinitions(db)) {
                Utils.Ui.SelectStyle selStyleForm = new Utils.Ui.SelectStyle(dict);
                selStyleForm.Text = "Select Property Set Definition";
                if (selStyleForm.ShowDialog() == DialogResult.OK)
                    styleId = selStyleForm.SelectedStyleId();
            }
		    
            if (styleId.IsNull) {
                MessageBox.Show("No defintions are available to choose from.");
            }
		    
            return styleId;
        }

        #endregion  // specific dictionary types


	}
}
